# Issue Reporting

If you find a bug in the source code, you can help us by [submitting an issue](#submitting-an-issue) to our [GitHub Repository](https://github.com/wiris/moodle-filter_wiris). You can as well submit a Pull Request with a fix. Both issues and pull requests contain a template to follow.

We ask you to not open issues for general support questions as we want to keep GitHub issues for bug reports and feature requests.

Instead, we recommend you sending an e-mail to [support@wiris.com](mailto:support@wiris.com) to ask support-related questions.

## Submitting an Issue

Before you submit an issue, please **search the issue tracker**. The problem you are experiencing may have already been reported, and the discussion might provide helpful workarounds.

We strive to fix all the problems as soon as possible. However, before addressing a bug, we need to reproduce and confirm it.

To help us reproduce bugs effectively, we ask that you provide a **minimal reproduction**. It will a allow is to gather crucial information and avoid back-and-forth communication. With it, we will be able to:

* Quickly confirm whether it is a bug or a coding issue.
* Ensure we are addressing the correct problem. 

Unfortunately, we are not able to investigate or fix bugs without a minimal reproduction. In that case, we'll have to close the report.

You can file new issues by selecting our [new issue template](https://github.com/wiris/moodle-filter_wiris/issues/new/choose) and filling it out.